Subject: bug#70010: 30.0.50; completion-preview-mode behaves mode-local, but is global

From: Eshel Yaron <[email-masked]>
Date: Tue, 26 Mar 2024 22:49:04 +0100

Philip Kaludercic <[email-masked]> writes:

> Eshel Yaron <[email-masked]> writes:
>
>> Hello Philip,
>>
>> Philip Kaludercic <[email-masked]> writes:
>>
>>> I tried to enable `completion-preview-mode' by adding
>>>
>>>   (setopt completion-preview-mode t)
>>>
>>> in my init, but it had not effect.
>>
>> Indeed, it is a minor mode, so one normally enables it by calling the
>> function completion-preview-mode, perhaps interactively via M-x.
>
> I enable all minor modes as user options, so I'd disagree that using a
> function or invoking the command are the only ways to expect a minor
> mode to be enabled.

Fair enough :)

>>> When I check the implementation, I noticed that it modifies
>>> `post-command-hook' locally.  I think it would make sense to rename
>>> the current `completion-preview-mode' to
>>> `completion-preview-local-mode', and then use
>>> `define-globalized-minor-mode' to define `completion-preview-mode'.
>>
>> We can add a global variant, although IMO the natural scope for
>> completion-preview-mode is per major mode: for some kinds of content you
>> want to have completion preview, and for others you may want it off.
>> Note that a necessary condition for completion-preview-mode to be useful
>> in a certain context is that completion-at-point is useful in that
>> context, since otherwise there's nothing to preview.
>>
>> Therefore, I recommend enabling completion-preview-mode by adding it to
>> major mode hooks, such as prog-mode-hook or comint-mode-hook.
>> Admittedly, if you do want to enable it for all buffers, the major mode
>> hook approach would require adding it to four or five hooks, which is a
>> bit less elegant than enabling a global minor mode once.
>>
>> So I suggest we keep completion-preview-mode local and add a global
>> variant, say, completion-preview-global-mode, for enabling it globally.
>> WDYT?
>
> That seems fine as well.

All right, here's a patch that adds such a global variant.  I find the
:predicate argument of define-globalized-minor-mode pretty neat, it adds
a user option that lets users choose in which major modes the minor mode
should take effect, and we can provide a sane default:

>From caca8078f95b8e2d6c67ada1da6fdb024262c5bc Mon Sep 17 00:00:00 2001
From: Eshel Yaron <[email-masked]>
Date: Tue, 26 Mar 2024 22:34:51 +0100
Subject: [PATCH] Add global minor mode 'completion-preview-global-mode'

This is a global variant of 'completion-preview-mode'.

* lisp/completion-preview.el (completion-preview-global-mode): New
global minor mode.  (Bug#70010)
---
 lisp/completion-preview.el | 4 ++++
 1 file changed, 4 insertions(+)

diff --git a/lisp/completion-preview.el b/lisp/completion-preview.el
index 75386f96429..f8a3c5ac4a2 100644
--- a/lisp/completion-preview.el
+++ b/lisp/completion-preview.el
@@ -414,5 +414,9 @@ completion-preview-mode
     (remove-hook 'post-command-hook #'completion-preview--post-command t)
     (completion-preview-active-mode -1)))
 
+(define-globalized-minor-mode completion-preview-global-mode
+  completion-preview-mode completion-preview-mode
+  :predicate '((not minibuffer-mode special-mode) t))
+
 (provide 'completion-preview)
 ;;; completion-preview.el ends here
-- 
2.44.0